const http = require("http");

const debugOpt = "--debug true";
let debug = false;

process.argv.forEach((val, index, array) => {
  if (debugOpt === val) {
    debug = true;
  }
});

const webPrint = (res, respBody) => {
  res.writeHead(200, { Connection: "keep-alive" });
  res.write(respBody);
  res.end();
};

const webPrintResult = (res, result) => {
  webPrint(res, JSON.stringify(["ok", result]));
};

const webPrintError = (res, error) => {
  webPrint(res, JSON.stringify(["err", error.toString()]));
};

function isPromise(value) {
  return Boolean(value && typeof value.then === "function");
}

const server = http.createServer((req, res) => {
  let contents = "";

  req.on("data", (dataIn) => {
    contents += dataIn;
  });

  req.on("end", () => {
    try {
      const result = eval(contents);
      if (typeof result == "undefined" && result !== null) {
        webPrintResult(res, null);
      } else if (isPromise(result)) {
        result
          .then((value) => {
            webPrintResult(res, value);
          })
          .catch((err) => {
            webPrintError(res, err);
          });
      } else {
        try {
          webPrintResult(res, result);
        } catch (err) {
          webPrintError(res, err);
        }
      }
    } catch (err) {
      webPrintError(res, err);
    }
  });
});

const port = process.env.PORT || 3001;
server.listen(port);

if (debug) {
  console.log("Listening on port:", port);
  console.error("RubyAwaitNode.js started.  Piping coffee to warmer climates.");
}
